import { json, tsv } from 'd3';
import { feature } from 'topojson';

export const getData = () =>
	// Load Multiple Data Files
	Promise
		.all([
   		tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
      json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
  	])
		.then(([tsvData,topoJSONdata]) => {
      // Create Country Lookup data from tsv file
      const countryLkp = tsvData.reduce((a, d) => {
        a[d.iso_n3] = d;
        return a;
      }, {});

      // Create worldData from topoJSON file
      const worldData = feature(topoJSONdata,topoJSONdata.objects.countries).features;

      // Add Country Data to WorldData
      worldData.forEach( d => {
        Object.assign(d.properties, countryLkp[d.id]);
      });

      return worldData;
  }); 
